Subject: Re: [bug#37443] [PATCH] scripts: pull: Add options for generation management

From: Ludovic Courtès <[email-masked]>
Date: Thu, 19 Sep 2019 10:20:46 +0200

Hello,

Konrad Hinsen <[email-masked]> skribis:

>> Cool, applied!
>
> Great, thanks!
>
>> It’s great news that the MOOC will be talking about reproducible
>> research!

Uh, I meant: it’s great news that the MOOC on reproducible research will
be talking about Guix.

> That's what it has been doing for a while. The news is that it will
> contain a tutorial on using Guix. In parallel with the same task
> (defining/communicating/restoring a software environment) using
> a more heavyweight toolchain: Debian + debuerreotype + Docker.

I see.

>> Now, it’s true that having two different profiles appears to be hard
>> to grasp for newcomers, as Ricardo was saying just now on IRC.
>
> I suspect that the whole idea of profiles (as distinct from the user
> account) is not obvious. If I ever extend my tutorial to include
> profiles, I would probably introduce them as persistent environments.

Yeah, that’s what they are, so maybe it’s simpler to present profiles as
persistent environments.

> And since I am in criticizing mood, the whole Guix management API
> suffers from bad naming. Consider "guix pull -l". What does it pull?  Or
> "guix package –-roll-back", which doesn't roll back a package but a
> profile. Guix is following the lead of git whose command line API makes
> sense only to people who have seen it grow historically.

What would you suggest?  “guix log”, “guix roll-back”?

Thanks,
Ludo’.